      program compute_pi
      integer n,i
      double precision w,x,sum,pi,f,a
      parameter (n=10 000 000)
! times using cpu_time
      real t0
      real t1
c function to integrate
      f(a)=4.d0/(1.d0+a*a)
c
      call cpu_time(t0)
c calculate the interval size
      w=1.0d0/n
      sum=0.0d0
!$OMP PARALLEL PRIVATE(x), SHARED(w,sum)
!$OMP DO
      do i=1,n
        x=w*(i-0.5d0)
        sum=sum+f(x)
      enddo
!$OMP END DO
!$OMP END PARALLEL
      pi=w*sum
c
      call cpu_time(t1)
      write (*,'(/,a,1pg24.16)') 'computed pi = ', pi
      write (*,'(/,a,1pg12.4)')  'cpu_time  :   ', t1-t0
      stop
      end
